org.eclipse.viatra.query.runtime.matchers.psystem

## Class KeyedEnumerablePConstraint<KeyType>

- java.lang.Object
- - org.eclipse.viatra.query.runtime.matchers.psystem.BasePConstraint
  - - org.eclipse.viatra.query.runtime.matchers.psystem.EnumerablePConstraint
    - - org.eclipse.viatra.query.runtime.matchers.psystem.KeyedEnumerablePConstraint<KeyType>

- All Implemented Interfaces:
    PConstraint, PTraceable
  Direct Known Subclasses:
    BinaryTransitiveClosure, ConstantValue, PositivePatternCall, TypeConstraint

      public abstract class KeyedEnumerablePConstraint<KeyType>
      extends EnumerablePConstraint

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface org.eclipse.viatra.query.runtime.matchers.psystem.PConstraint

      `PConstraint.CompareByMonotonousID`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected KeyType` | `supplierKey`

    - ### Fields inherited from class org.eclipse.viatra.query.runtime.matchers.psystem.EnumerablePConstraint

      `variablesTuple`

    - ### Fields inherited from class org.eclipse.viatra.query.runtime.matchers.psystem.BasePConstraint

      `pBody`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `KeyedEnumerablePConstraint(PBody pBody, Tuple variablesTuple, KeyType supplierKey)`

  - ### Method Summary

    All Methods Instance Methods Abstract Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `KeyType` | `getSupplierKey()`
    `protected abstract java.lang.String` | `keyToString()`
    `protected java.lang.String` | `toStringRestRest()`

    - ### Methods inherited from class org.eclipse.viatra.query.runtime.matchers.psystem.EnumerablePConstraint

      `doReplaceVariable, getDeducedVariables, getVariableInTuple, getVariablesTuple, toStringRest`

    - ### Methods inherited from class org.eclipse.viatra.query.runtime.matchers.psystem.BasePConstraint

      `checkSanity, delete, getAffectedVariables, getFunctionalDependencies, getMonotonousID, getPSystem, replaceVariable, toString`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### supplierKey

          protected KeyType supplierKey

  - ### Constructor Detail

    - #### KeyedEnumerablePConstraint

          public KeyedEnumerablePConstraint(PBody pBody,
                                            Tuple variablesTuple,
                                            KeyType supplierKey)

  - ### Method Detail

    - #### toStringRestRest

          protected java.lang.String toStringRestRest()

      Overrides:
        `toStringRestRest` in class `EnumerablePConstraint`

    - #### keyToString

          protected abstract java.lang.String keyToString()

    - #### getSupplierKey

          public KeyType getSupplierKey()